Require Import connectives.
Require Import leibniz.
Require Import logic.
Parameter nat : Type.
Parameter O : nat.
Parameter S : nat -> nat.
Axiom match_nat_prop : forall (return_:(nat -> Prop)), (return_ O) -> (forall (n:nat), return_ (S n)) -> forall (z:nat), return_ z.
Parameter match_nat_type : forall (return_:Type), return_ -> (nat -> return_) -> nat -> return_.
Axiom axiom_match_nat_type_O : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), connectives.equal (return_type) (match_nat_type (return_type) case_O case_S O) case_O.
Definition eq_match_nat_type_O : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), leibniz.leibniz (return_type) (match_nat_type (return_type) case_O case_S O) case_O := fun (return_type:Type) => fun (case_O:return_type) => fun (case_S:nat -> return_type) => ((((connectives.equal_leibniz) (return_type)) (match_nat_type (return_type) case_O case_S O)) (case_O)) ((((axiom_match_nat_type_O) (return_type)) (case_O)) (case_S)).
Definition sym_eq_match_nat_type_O : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), leibniz.leibniz (return_type) case_O (match_nat_type (return_type) case_O case_S O) := fun (return_type:Type) => fun (case_O:return_type) => fun (case_S:nat -> return_type) => ((((leibniz.sym_leibniz) (return_type)) (match_nat_type (return_type) case_O case_S O)) (case_O)) ((((eq_match_nat_type_O) (return_type)) (case_O)) (case_S)).
Parameter filter_nat_type : forall (return_:Type), (nat -> return_) -> nat -> return_.
Axiom axiom_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), connectives.equal (return_type) (filter_nat_type (return_type) return_ O) (return_ O).
Definition eq_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), leibniz.leibniz (return_type) (filter_nat_type (return_type) return_ O) (return_ O) := fun (return_type:Type) => fun (return_:nat -> return_type) => ((((connectives.equal_leibniz) (return_type)) (filter_nat_type (return_type) return_ O)) (return_ O)) (((axiom_filter_nat_type_O) (return_type)) (return_)).
Definition sym_eq_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), leibniz.leibniz (return_type) (return_ O) (filter_nat_type (return_type) return_ O) := fun (return_type:Type) => fun (return_:nat -> return_type) => ((((leibniz.sym_leibniz) (return_type)) (filter_nat_type (return_type) return_ O)) (return_ O)) (((eq_filter_nat_type_O) (return_type)) (return_)).
Axiom axiom_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), connectives.equal (return_type) (filter_nat_type (return_type) return_ (S n)) (return_ (S n)).
Definition eq_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (filter_nat_type (return_type) return_ (S n)) (return_ (S n)) := fun (return_type:Type) => fun (return_:nat -> return_type) => fun (n:nat) => ((((connectives.equal_leibniz) (return_type)) (filter_nat_type (return_type) return_ (S n))) (return_ (S n))) ((((axiom_filter_nat_type_S) (return_type)) (return_)) (n)).
Definition sym_eq_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (return_ (S n)) (filter_nat_type (return_type) return_ (S n)) := fun (return_type:Type) => fun (return_:nat -> return_type) => fun (n:nat) => ((((leibniz.sym_leibniz) (return_type)) (filter_nat_type (return_type) return_ (S n))) (return_ (S n))) ((((eq_filter_nat_type_S) (return_type)) (return_)) (n)).
Parameter le : nat -> nat -> Prop.
Definition lt : nat -> nat -> Prop := fun (n:nat) => fun (m:nat) => le (S n) m.
Parameter minus : nat -> nat -> nat.
Parameter minus_body : nat -> nat -> nat.
Axiom axiom_minus : forall (n:nat), connectives.equal (nat -> nat) (minus n) (filter_nat_type (nat -> nat) minus_body n).
Definition eq_minus : forall (n:nat), leibniz.leibniz (nat -> nat) (minus n) (filter_nat_type (nat -> nat) minus_body n) := fun (n:nat) => ((((connectives.equal_leibniz) (nat -> nat)) (minus n)) (filter_nat_type (nat -> nat) minus_body n)) ((axiom_minus) (n)).
Definition sym_eq_minus : forall (n:nat), leibniz.leibniz (nat -> nat) (filter_nat_type (nat -> nat) minus_body n) (minus n) := fun (n:nat) => ((((leibniz.sym_leibniz) (nat -> nat)) (minus n)) (filter_nat_type (nat -> nat) minus_body n)) ((eq_minus) (n)).
Axiom axiom_minus_body_O : connectives.equal (nat -> nat) (minus_body O) (fun (m:nat) => O).
Definition eq_minus_body_O : leibniz.leibniz (nat -> nat) (minus_body O) (fun (m:nat) => O) := ((((connectives.equal_leibniz) (nat -> nat)) (minus_body O)) (fun (m:nat) => O)) (axiom_minus_body_O).
Definition sym_eq_minus_body_O : leibniz.leibniz (nat -> nat) (fun (m:nat) => O) (minus_body O) := ((((leibniz.sym_leibniz) (nat -> nat)) (minus_body O)) (fun (m:nat) => O)) (eq_minus_body_O).
Axiom axiom_minus_body_S : forall (n:nat), connectives.equal (nat -> nat) (minus_body (S n)) (fun (m:nat) => match_nat_type (nat) (S n) (fun (q:nat) => minus n q) m).
Definition eq_minus_body_S : forall (n:nat), leibniz.leibniz (nat -> nat) (minus_body (S n)) (fun (m:nat) => match_nat_type (nat) (S n) (fun (q:nat) => minus n q) m) := fun (n:nat) => ((((connectives.equal_leibniz) (nat -> nat)) (minus_body (S n))) (fun (m:nat) => match_nat_type (nat) (S n) (fun (q:nat) => minus n q) m)) ((axiom_minus_body_S) (n)).
Definition sym_eq_minus_body_S : forall (n:nat), leibniz.leibniz (nat -> nat) (fun (m:nat) => match_nat_type (nat) (S n) (fun (q:nat) => minus n q) m) (minus_body (S n)) := fun (n:nat) => ((((leibniz.sym_leibniz) (nat -> nat)) (minus_body (S n))) (fun (m:nat) => match_nat_type (nat) (S n) (fun (q:nat) => minus n q) m)) ((eq_minus_body_S) (n)).
Definition minus_O_n : forall (n:nat), logic.eq (nat) O (minus O n) := fun (n:nat) => ((((match_nat_prop) (fun (__:nat) => logic.eq (nat) O (minus O __))) ((((sym_eq_minus) (O)) (fun (y:(nat -> nat)) => logic.eq (nat) O (y O))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (minus_body)) (fun (y:(nat -> nat)) => logic.eq (nat) O (y O))) (((sym_eq_minus_body_O) (fun (y:(nat -> nat)) => logic.eq (nat) O (y O))) (((logic.refl) (nat)) (O)))))) ((((sym_eq_minus) (O)) (fun (y:(nat -> nat)) => forall (n0:nat), logic.eq (nat) O (y (S n0)))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (minus_body)) (fun (y:(nat -> nat)) => forall (n0:nat), logic.eq (nat) O (y (S n0)))) (((sym_eq_minus_body_O) (fun (y:(nat -> nat)) => forall (n0:nat), logic.eq (nat) O (y (S n0)))) (fun (auto:nat) => ((logic.refl) (nat)) (O)))))) (n).
Definition minus_n_O : forall (n:nat), logic.eq (nat) n (minus n O) := fun (n:nat) => ((((match_nat_prop) (fun (__:nat) => logic.eq (nat) __ (minus __ O))) (((((((logic.rewrite_l) (nat)) (O)) (fun (__:nat) => logic.eq (nat) O __)) (((logic.refl) (nat)) (O))) (minus O O)) ((minus_O_n) (O)))) (fun (auto:nat) => (((sym_eq_minus) (S auto)) (fun (y:(nat -> nat)) => logic.eq (nat) (S auto) (y O))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (minus_body)) (auto)) (fun (y:(nat -> nat)) => logic.eq (nat) (S auto) (y O))) ((((sym_eq_minus_body_S) (auto)) (fun (y:(nat -> nat)) => logic.eq (nat) (S auto) (y O))) ((((((sym_eq_match_nat_type_O) (nat)) (S auto)) (fun (q:nat) => minus auto q)) (fun (y:nat) => logic.eq (nat) (S auto) y)) (((logic.refl) (nat)) (S auto))))))) (n).
